(* incorrect call passing explicitly out-of-range value to in parameter violating pre-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> in[integer]] -> {pre -> x < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[150]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                1,
                {},
                {
                    {
                        "Operation call pre-conditions.",
                        alwaysT[False]
                    }
                }
            }
        },
        <||>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Operation call pre-conditions.", 
                        alwaysT[False]
                    },
                    failedT[]
                }
            },
        bar -> {}
        |>
    |>
]
