(* incorrect assignment of explicit out-of-range value to local variable protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
        x -> smallInt
    },
    x = 150
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {!initializedT[x]},
                {}
            },
            {
                1,
                {!initializedT[x], initializedT[Subscript[x, 1]], Subscript[x, 1] == 150},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[x, 1] <= 100]
                    }
                }
            },
            {
                "finish",
                {!initializedT[x], initializedT[Subscript[x, 1]], Subscript[x, 1] == 150},
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 1]]]
                    }
                }
            }
        },
        <|x -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[0 <= Subscript[x, 1] <= 100]
                    },
                    failedT[x -> 0, Subscript[x, 1] -> 150, initializedT[x] -> False, initializedT[Subscript[x, 1]] -> True]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 1]]]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
