(* assignment to package variable with post-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[] -> {post -> x < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = 0
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, Subscript[P`x, 1] == 0},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {-2147483648 <= P`x <= 2147483647, Subscript[P`x, 1] == 0},
                {
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[P`x, 1] < 100]
                    }
                }
            }
        },
        <|P`x -> Integers, Subscript[P`x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[P`x, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[P`x, 1] < 100]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
