(* incorrect assignment of explicit out-of-range value to in-out parameter protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
declareOperations[sys, "P`",
    {
        foo[x -> inOut[smallInt]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = 150
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {0 <= x <= 100},
                {}
            },
            {
                1,
                {0 <= x <= 100, Subscript[x, 1] == 150},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[x, 1] <= 100]
                    }
                }
            }
        },
        <|x -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[0 <= Subscript[x, 1] <= 100]
                    },
                    failedT[x -> 0, Subscript[x, 1] -> 150]
                }
            }
        |>
    |>
]
