(* assignment to out parameter with post-condition *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[x -> out[integer]] -> {post -> x < 100}
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    x = 0
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {!initializedT[x]},
                {}
            },
            {
                1,
                {!initializedT[x], initializedT[Subscript[x, 1]], Subscript[x, 1] == 0},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    }
                }
            },
            {
                "finish",
                {!initializedT[x], initializedT[Subscript[x, 1]], Subscript[x, 1] == 0},
                {
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 1]]]
                    },
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[x, 1] < 100]
                    }
                }
            }
        },
        <|x -> Integers, Subscript[x, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[-2147483648 <= Subscript[x, 1] <= 2147483647]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Variable should be initialized on some path.",
                        possibleT[initializedT[Subscript[x, 1]]]
                    },
                    provenT[]
                },
                {
                    "finish",
                    {
                        "Operation post-conditions.",
                        alwaysT[Subscript[x, 1] < 100]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
