(* one empty function *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    Null
];

grChecks = reportGrammarChecks[sys];
Assert[grChecks === <|"P`" -> <|foo -> True|>|>]

nChecks = reportNameChecks[sys];
Assert[nChecks === <|"P`" -> {{}, <|foo -> {}|>}|>]

fChecks = reportFlowChecks[sys];
Assert[fChecks === <|"P`" -> <|foo -> {}|>|>]

calls = reportCallGraph[sys];
Assert[calls === {}]

proofSt = reportProofStatements[sys, "P`", foo]
Assert[proofSt === {{}, <||>}]

proofs = reportProofs[sys];
Assert[proofs === <|"P`" -> <|foo -> {}|>|>]
