(* ghost variable used in pre-condition and properly set before the call *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[] -> {pre -> g}
    }
];
setGhostDomains[sys, Element[g, Booleans]];
defineOperation[sys, "P`", foo,
    {
    },
    Assume[g]
    bar[]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {},
        <||>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo -> {},
        bar -> {}
        |>
    |>
]
