(* ghost variable used in pre-condition and not properly set before the call *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[],
        bar[] -> {pre -> g}
    }
];
setGhostDomains[sys, Element[g, Booleans]];
defineOperation[sys, "P`", foo,
    {
    },
    (* g not set *)
    bar[]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                1,
                {},
                {
                    {
                        "Operation call pre-conditions.",
                        alwaysT[g]
                    }
                }
            }
        },
        <||>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Operation call pre-conditions.",
                        alwaysT[g]
                    },
                    failedT[g -> False]
                }
            },
        bar -> {}
        |>
    |>
]
