(* incorrect operation call with explicit out-of-range value for in parameter protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
declareOperations[sys, "P`",
    {
        foo[],
        bar[x -> in[smallInt]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    bar[150]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                1,
                {},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[False]
                    }
                }
            }
        },
        <||>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[False]
                    },
                    failedT[]
                }
            },
        bar -> {}
        |>
    |>
]
