(* incorrect assignment of potentially out-of-range value to package variable protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
defineDataObjects[sys, "P`",
    {
        x -> integer,
        y -> smallInt
    }
];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    y = x
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, 0 <= P`y <= 100},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, 0 <= P`y <= 100, P`x == Subscript[P`y, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[P`y, 1] <= 100]
                    }
                }
            }
        },
        <|P`x -> Integers, P`y -> Integers, Subscript[P`y, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[0 <= Subscript[P`y, 1] <= 100]
                    },
                    failedT[P`x -> -2, P`y -> 0, Subscript[P`y, 1] -> -2]
                }
            }
        |>
    |>
]
