(* incorrect assignment of potentially out-of-range value to in-out parameter protected by subtype *)

sys = newSystem[];
declarePackage[sys, "P`"];
defineDataTypes[sys, "P`",
    {
        smallInt -> number[base -> integer, invariant -> 0 <= smallInt <= 100]
    }
]
defineDataObjects[sys, "P`",
    {
        x -> integer
    }
];
declareOperations[sys, "P`",
    {
        foo[y -> inOut[smallInt]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    y = x
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= P`x <= 2147483647, 0 <= y <= 100},
                {}
            },
            {
                1,
                {-2147483648 <= P`x <= 2147483647, 0 <= y <= 100, P`x == Subscript[y, 1]},
                {
                    {
                        "Value should fit the target type.",
                        alwaysT[0 <= Subscript[y, 1] <= 100]
                    }
                }
            }
        },
        <|P`x -> Integers, y -> Integers, Subscript[y, 1] -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    1,
                    {
                        "Value should fit the target type.", 
                        alwaysT[0 <= Subscript[y, 1] <= 100]
                    },
                    failedT[P`x -> -2, y -> 0, Subscript[y, 1] -> -2]
                }
            }
        |>
    |>
]
