(* assume influencing further assert *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[x -> in[integer]]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    Assume[x < -10];
    Assert[x < 0, "x must be negative"]
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "start",
                {-2147483648 <= x <= 2147483647},
                {}
            },
            {
                1,
                {-2147483648 <= x <= 2147483647, x < -10},
                {}
            },
            {
                2,
                {-2147483648 <= x <= 2147483647, x < -10},
                {
                    {
                        "x must be negative",
                        alwaysT[x < 0]
                    }
                }
            }
        },
        <|x -> Integers|>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    2,
                    {
                        "x must be negative",
                        alwaysT[x < 0]
                    },
                    provenT[]
                }
            }
        |>
    |>
]
