(* ghost variable used in post-condition and not set as expected *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[] -> {post -> g}
    }
];
setGhostDomains[sys, Element[g, Booleans]];
defineOperation[sys, "P`", foo,
    {
    },
    Null (* g is not set*)
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                "finish",
                {
                },
                {
                    {
                        "Operation post-conditions.",
                        alwaysT[g]
                    }
                }
            }
        },
        <||>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    "finish",
                    {
                        "Operation post-conditions.",
                        alwaysT[g]
                    },
                    failedT[g -> False]
                }
            }
        |>
    |>
]
