(* ghost variable capture and recall *)

sys = newSystem[];
declarePackage[sys, "P`"];
declareOperations[sys, "P`",
    {
        foo[]
    }
];
defineOperation[sys, "P`", foo,
    {
    },
    GhostCapture["myGhost", 42];
    Assert[GhostRecall["myGhost"] == 42, "test1"];
    Assert[GhostRecall["myGhost"] == 43, "test2"];
];

proofSt = reportProofStatements[sys, "P`", foo];
Assert[proofSt ===
    {
        {
            {
                3,
                {},
                {
                    {
                        "test2",
                        alwaysT[False]
                    }
                }
            }
        },
        <||>
    }
]

proofs = reportProofs[sys];
Assert[proofs ===
    <|"P`" ->
        <|foo ->
            {
                {
                    3,
                    {
                        "test2",
                        alwaysT[False]
                    },
                    failedT[]
                }
            }
        |>
    |>
]
